using System;
using System.Text;
using System.Xml;
using System.Xml.Serialization;
using System.Runtime.Serialization;
using System.ComponentModel;
using System.Windows.Forms;

namespace DkmS.Office2003 {
	public abstract class Config{
		public object RestoreFrom(string FileName){
			Type t=this.GetType();
			XmlSerializer serializer = new XmlSerializer(t);
			serializer.UnknownNode+=new XmlNodeEventHandler(serializer_UnknownNode);
			serializer.UnknownAttribute+=new XmlAttributeEventHandler(serializer_UnknownAttribute);
			XmlTextReader reader=null;
			try{
				reader = new XmlTextReader(FileName);
				return serializer.Deserialize(reader);
			}catch(Exception er){
				string sss=er.ToString();
				return null;
			}finally{
				if(reader!=null) reader.Close();
			}
		}
		public bool SaveTo(string FileName){
			XmlSerializer serializer;
			Type t = this.GetType();
			XmlTextWriter writer=null;
			try{
				serializer = new XmlSerializer(t);
				writer = new XmlTextWriter(FileName, Encoding.Unicode);
				writer.Formatting = Formatting.Indented;
				serializer.Serialize(writer, this);
				return true;
			}catch(Exception err){
				MessageBox.Show(err.Message,"Error while save config");
				return false;
			}finally{
				if(writer!=null) writer.Close();
			}
		}
		private void serializer_UnknownNode(object sender, XmlNodeEventArgs e) {}
		private void serializer_UnknownAttribute(object sender, XmlAttributeEventArgs e) {}
	}
}