using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.Win32;
using DkmS.Office2003;
using WmpNowRS;
using System.Xml.Serialization;
using System.Text.RegularExpressions;
using System.Reflection;
namespace ieExt
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form {
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage InfoTabPage;
		private System.Windows.Forms.TabPage InstallTabPage;
		private System.Windows.Forms.Button InstallButton;
		private System.Windows.Forms.ToolTip toolTip;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label cprLabel;
		private System.Windows.Forms.LinkLabel addrLinkLabel;
		private System.Windows.Forms.TextBox infoPathTextBox;
		private System.Windows.Forms.TextBox infoFmtTextBox;
		private System.Windows.Forms.Button SaveButton;
		private System.Windows.Forms.Label ExampleLabel;
		private System.Windows.Forms.Button OkButton;
		private System.Windows.Forms.Button CancelBtn;
		private System.Windows.Forms.Label VerLabel;
		private System.Windows.Forms.Label DescrLabel;
		private System.Windows.Forms.Label WarnLabel;
		private System.ComponentModel.IContainer components;

		public MainForm() {
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			SetButton();
			RestoreCfg();
			info.RestoreFrom(cfg.Path);
			try{
				ExampleLabel.Text=/*"Result:\n"+*/FormatData(infoFmt);
			}catch{
				ExampleLabel.Text="Format string not valid...";
			}
			this.toolTip.SetToolTip(this.infoFmtTextBox, @"Format string [like in String.Format()]:
{0} - Name of media,
{1} - Album, {2} - Artist, {3} - Genre,
{4} - Type(wma,mp3 etc), {5} - Bitrate,
{6} - Duration, {7} - PlayerVersion
");
			GetAttrs();
			this.Text=assTitle;
			VerLabel.Text=assTitle+" ver."+assVersion;
			WarnLabel.Visible=false;
		}
		string assTitle="Now Playing", assVersion="", assDescription="";
		void GetAttrs(){
			Assembly The=Assembly.GetExecutingAssembly();
			Object[] TA = The.GetCustomAttributes(true);
			foreach(Object attr in TA) {
				switch(attr.GetType().Name){
					case "AssemblyTitleAttribute":
						assTitle=((AssemblyTitleAttribute)attr).Title;
						break;
					case "AssemblyDescriptionAttribute":
						assDescription=((AssemblyDescriptionAttribute)attr).Description;
						break;
					case "AssemblyVersionAttribute":
						assVersion=((AssemblyVersionAttribute)attr).Version;
						break;
				}
			}
			if(assVersion==""){//   FullName
				Regex reVer=new Regex(@"version\s*=\s*(?<assVersion>\d+\.\d+\.\d+)", RegexOptions.IgnoreCase);
				if(reVer.IsMatch(The.FullName))
					assVersion=reVer.Match(The.FullName).Result("${assVersion}");
			}
		}

		string infoFmt="",infoPath="";
		#region Config
		NowPlayingPluginConfig cfg=new NowPlayingPluginConfig();
		string Join(string[] arr,string delim){
			string retval="";
			for(int i=0;i<arr.Length;i++){
				retval+=(i>0?delim:"") + arr[i];
			}
			return retval;
		}
		void RestoreCfg() {
			try{
				this.cfg=(NowPlayingPluginConfig)cfg.RestoreFrom(this.ConfigFileName);
			}catch(Exception er){
				MessageBox.Show(er.ToString());
			}
			try{
				if(cfg==null){
					cfg=new NowPlayingPluginConfig();
				}//else{
				this.infoPath=cfg.Path;
				this.infoPathTextBox.Text=this.infoPath;
				this.infoFmt=Join(cfg.Format,Environment.NewLine);
				this.infoFmtTextBox.Text=this.infoFmt;
				//}
			}catch(Exception err){
				MessageBox.Show(err.Message+"\n"+err.StackTrace,this.Name);
			}
		}
		void SaveCfg() {
			cfg.SaveTo(this.ConfigFileName);
		}
		#endregion

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				//				SaveCfg();
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.InfoTabPage = new System.Windows.Forms.TabPage();
			this.InstallTabPage = new System.Windows.Forms.TabPage();
			this.InstallButton = new System.Windows.Forms.Button();
			this.toolTip = new System.Windows.Forms.ToolTip(this.components);
			this.panel1 = new System.Windows.Forms.Panel();
			this.cprLabel = new System.Windows.Forms.Label();
			this.VerLabel = new System.Windows.Forms.Label();
			this.addrLinkLabel = new System.Windows.Forms.LinkLabel();
			this.infoPathTextBox = new System.Windows.Forms.TextBox();
			this.infoFmtTextBox = new System.Windows.Forms.TextBox();
			this.SaveButton = new System.Windows.Forms.Button();
			this.ExampleLabel = new System.Windows.Forms.Label();
			this.OkButton = new System.Windows.Forms.Button();
			this.CancelBtn = new System.Windows.Forms.Button();
			this.DescrLabel = new System.Windows.Forms.Label();
			this.WarnLabel = new System.Windows.Forms.Label();
			this.tabControl1.SuspendLayout();
			this.InfoTabPage.SuspendLayout();
			this.InstallTabPage.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.InfoTabPage);
			this.tabControl1.Controls.Add(this.InstallTabPage);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl1.Location = new System.Drawing.Point(0, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(296, 296);
			this.tabControl1.TabIndex = 0;
			// 
			// InfoTabPage
			// 
			this.InfoTabPage.Controls.Add(this.CancelBtn);
			this.InfoTabPage.Controls.Add(this.OkButton);
			this.InfoTabPage.Controls.Add(this.ExampleLabel);
			this.InfoTabPage.Controls.Add(this.SaveButton);
			this.InfoTabPage.Controls.Add(this.infoFmtTextBox);
			this.InfoTabPage.Controls.Add(this.infoPathTextBox);
			this.InfoTabPage.Location = new System.Drawing.Point(4, 22);
			this.InfoTabPage.Name = "InfoTabPage";
			this.InfoTabPage.Size = new System.Drawing.Size(288, 270);
			this.InfoTabPage.TabIndex = 0;
			this.InfoTabPage.Text = "WMP info";
			this.InfoTabPage.ToolTipText = "Information about WMP";
			// 
			// InstallTabPage
			// 
			this.InstallTabPage.Controls.Add(this.WarnLabel);
			this.InstallTabPage.Controls.Add(this.panel1);
			this.InstallTabPage.Controls.Add(this.InstallButton);
			this.InstallTabPage.Location = new System.Drawing.Point(4, 22);
			this.InstallTabPage.Name = "InstallTabPage";
			this.InstallTabPage.Size = new System.Drawing.Size(288, 270);
			this.InstallTabPage.TabIndex = 1;
			this.InstallTabPage.Text = "About";
			this.InstallTabPage.ToolTipText = "Install/uninstall in IE";
			// 
			// InstallButton
			// 
			this.InstallButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.InstallButton.BackColor = System.Drawing.Color.Honeydew;
			this.InstallButton.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.InstallButton.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.InstallButton.ForeColor = System.Drawing.Color.Firebrick;
			this.InstallButton.Location = new System.Drawing.Point(112, 231);
			this.InstallButton.Name = "InstallButton";
			this.InstallButton.Size = new System.Drawing.Size(79, 23);
			this.InstallButton.TabIndex = 0;
			this.InstallButton.Text = "Install";
			this.toolTip.SetToolTip(this.InstallButton, "Install/uninstall this extension");
			this.InstallButton.Click += new System.EventHandler(this.InstallButton_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.DescrLabel);
			this.panel1.Controls.Add(this.addrLinkLabel);
			this.panel1.Controls.Add(this.VerLabel);
			this.panel1.Controls.Add(this.cprLabel);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(288, 184);
			this.panel1.TabIndex = 1;
			// 
			// cprLabel
			// 
			this.cprLabel.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.cprLabel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.cprLabel.Location = new System.Drawing.Point(16, 152);
			this.cprLabel.Name = "cprLabel";
			this.cprLabel.Size = new System.Drawing.Size(104, 24);
			this.cprLabel.TabIndex = 0;
			this.cprLabel.Text = " DkmS, 2004";
			this.cprLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// VerLabel
			// 
			this.VerLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.VerLabel.BackColor = System.Drawing.Color.Gainsboro;
			this.VerLabel.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.VerLabel.Location = new System.Drawing.Point(16, 24);
			this.VerLabel.Name = "VerLabel";
			this.VerLabel.Size = new System.Drawing.Size(256, 24);
			this.VerLabel.TabIndex = 1;
			this.VerLabel.Text = "version";
			this.VerLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// addrLinkLabel
			// 
			this.addrLinkLabel.Location = new System.Drawing.Point(144, 152);
			this.addrLinkLabel.Name = "addrLinkLabel";
			this.addrLinkLabel.Size = new System.Drawing.Size(128, 24);
			this.addrLinkLabel.TabIndex = 2;
			this.addrLinkLabel.TabStop = true;
			this.addrLinkLabel.Text = "dkms@mail.ru";
			this.addrLinkLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.toolTip.SetToolTip(this.addrLinkLabel, "Ask your questions");
			this.addrLinkLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.addrLinkLabel_LinkClicked);
			// 
			// infoPathTextBox
			// 
			this.infoPathTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.infoPathTextBox.Location = new System.Drawing.Point(8, 8);
			this.infoPathTextBox.Name = "infoPathTextBox";
			this.infoPathTextBox.Size = new System.Drawing.Size(276, 20);
			this.infoPathTextBox.TabIndex = 4;
			this.infoPathTextBox.Text = "infoPath";
			this.toolTip.SetToolTip(this.infoPathTextBox, "Path to information file (e.g. C:\\Program Files\\DkmS\\Wmp Now\\Msg\\audio.wmpnow)");
			this.infoPathTextBox.TextChanged += new System.EventHandler(this.infoPathTextBox_TextChanged);
			this.infoPathTextBox.Leave += new System.EventHandler(this.infoPathTextBox_Leave);
			// 
			// infoFmtTextBox
			// 
			this.infoFmtTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.infoFmtTextBox.BackColor = System.Drawing.Color.WhiteSmoke;
			this.infoFmtTextBox.Location = new System.Drawing.Point(8, 32);
			this.infoFmtTextBox.Multiline = true;
			this.infoFmtTextBox.Name = "infoFmtTextBox";
			this.infoFmtTextBox.Size = new System.Drawing.Size(276, 88);
			this.infoFmtTextBox.TabIndex = 2;
			this.infoFmtTextBox.Text = "infoFmt";
			this.toolTip.SetToolTip(this.infoFmtTextBox, "Format string (like in String.Format():");
			this.infoFmtTextBox.TextChanged += new System.EventHandler(this.infoFmtTextBox_TextChanged);
			this.infoFmtTextBox.Leave += new System.EventHandler(this.infoFmtTextBox_Leave);
			// 
			// SaveButton
			// 
			this.SaveButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.SaveButton.BackColor = System.Drawing.Color.Lavender;
			this.SaveButton.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.SaveButton.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.SaveButton.Location = new System.Drawing.Point(16, 128);
			this.SaveButton.Name = "SaveButton";
			this.SaveButton.Size = new System.Drawing.Size(256, 16);
			this.SaveButton.TabIndex = 3;
			this.SaveButton.Text = "Save configuration";
			this.SaveButton.Click += new System.EventHandler(this.SaveButton_Click);
			// 
			// ExampleLabel
			// 
			this.ExampleLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ExampleLabel.BackColor = System.Drawing.Color.GhostWhite;
			this.ExampleLabel.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.ExampleLabel.Location = new System.Drawing.Point(8, 152);
			this.ExampleLabel.Name = "ExampleLabel";
			this.ExampleLabel.Size = new System.Drawing.Size(272, 72);
			this.ExampleLabel.TabIndex = 3;
			this.ExampleLabel.Text = "Example Here";
			this.toolTip.SetToolTip(this.ExampleLabel, "Formatted info");
			this.ExampleLabel.UseMnemonic = false;
			// 
			// OkButton
			// 
			this.OkButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.OkButton.Location = new System.Drawing.Point(8, 240);
			this.OkButton.Name = "OkButton";
			this.OkButton.Size = new System.Drawing.Size(64, 24);
			this.OkButton.TabIndex = 0;
			this.OkButton.Text = "Copy";
			this.toolTip.SetToolTip(this.OkButton, "Copy information into clipboard");
			this.OkButton.Click += new System.EventHandler(this.OkButton_Click);
			// 
			// CancelBtn
			// 
			this.CancelBtn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.CancelBtn.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.CancelBtn.Location = new System.Drawing.Point(216, 240);
			this.CancelBtn.Name = "CancelBtn";
			this.CancelBtn.Size = new System.Drawing.Size(64, 24);
			this.CancelBtn.TabIndex = 1;
			this.CancelBtn.Text = "Cancel";
			this.toolTip.SetToolTip(this.CancelBtn, "Do nothing");
			this.CancelBtn.Click += new System.EventHandler(this.CancelButton_Click);
			// 
			// DescrLabel
			// 
			this.DescrLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.DescrLabel.Location = new System.Drawing.Point(11, 64);
			this.DescrLabel.Name = "DescrLabel";
			this.DescrLabel.Size = new System.Drawing.Size(266, 48);
			this.DescrLabel.TabIndex = 3;
			this.DescrLabel.Text = "Internet Explorer extension to put information about Windows Media Player into cl" +
				"ipboard ";
			this.DescrLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// WarnLabel
			// 
			this.WarnLabel.BackColor = System.Drawing.Color.LightPink;
			this.WarnLabel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.WarnLabel.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.WarnLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.WarnLabel.Location = new System.Drawing.Point(80, 200);
			this.WarnLabel.Name = "WarnLabel";
			this.WarnLabel.Size = new System.Drawing.Size(144, 16);
			this.WarnLabel.TabIndex = 2;
			this.WarnLabel.Text = "Restart IE";
			this.WarnLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.WarnLabel.Visible = false;
			// 
			// MainForm
			// 
			this.AcceptButton = this.OkButton;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.CancelBtn;
			this.ClientSize = new System.Drawing.Size(296, 296);
			this.Controls.Add(this.tabControl1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Now Playing";
			this.tabControl1.ResumeLayout(false);
			this.InfoTabPage.ResumeLayout(false);
			this.InstallTabPage.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() {
			Application.Run(new MainForm());
		}

		#region Install
		private void InstallButton_Click(object sender, System.EventArgs e) {
			if(!IsInstalled())
				Install();
			else
				UnInstall();
			SetButton();
		}
		static string GUID = "{EA3AC026-C720-4516-90ED-41DA714D1AE1}";
		string CLSID="{1FBA04EE-3024-11d2-8F1F-0000F87ABD16}"; //for *.exe
		string ADDRESS = @"Software\Microsoft\Internet Explorer\Extensions\" + GUID;
		public string ConfigFileName{
			get{ return this.GetType().Module.FullyQualifiedName+"._config";}
		}
		void Install(){
			string Exec=/*path to this exe*/
				this.GetType().Module.FullyQualifiedName;
			string MenuStatusBar="Put information into Clipboard";
			string MenuText="W&MP info...";
			RegistryKey rk=Registry.LocalMachine;
			try{
				rk=rk.CreateSubKey(ADDRESS);
				rk.SetValue("Exec",Exec);
				rk.SetValue("MenuStatusBar",MenuStatusBar);
				rk.SetValue("MenuText",MenuText);
				rk.SetValue("CLSID",CLSID);
			}catch(Exception er){
				MessageBox.Show(er.Message,"Error...");
			}
		}

		void UnInstall(){
			try{
				Registry.LocalMachine.DeleteSubKey(ADDRESS);
			}catch(Exception er){
				MessageBox.Show(er.Message,"Error...");
			}
		}
		Boolean IsInstalled(){
			RegistryKey rk=Registry.LocalMachine;
			object rv=rk.OpenSubKey(ADDRESS);
			return rv != null;
		}

		private void addrLinkLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) {
			string target = "mailto:" + (sender as LinkLabel).Text + "&Subject=WmpNowPlaying";
			System.Diagnostics.Process.Start(target);
		}

		void SetButton(){
			if(!IsInstalled()){
				InstallButton.Text="Install";
				this.InstallButton.BackColor = System.Drawing.Color.Honeydew;
				this.InstallButton.ForeColor = System.Drawing.Color.Firebrick;
				this.InstallButton.Font=new Font(this.InstallButton.Font,FontStyle.Bold);
				this.toolTip.SetToolTip(this.InstallButton, "Install this extension");
			}else{
				InstallButton.Text="UnInstall";
				this.InstallButton.BackColor = System.Drawing.Color.MistyRose;
				this.InstallButton.ForeColor = System.Drawing.Color.Blue;
				this.InstallButton.Font=new Font(this.InstallButton.Font,FontStyle.Regular);
				this.toolTip.SetToolTip(this.InstallButton, "Uninstall this extension");
			}
			WarnLabel.Visible=true;
		}
		#endregion
		bool infoPathChanged=false;
		private void infoPathTextBox_TextChanged(object sender, System.EventArgs e) {
			infoPathChanged=true;
		}
		private void infoPathTextBox_Leave(object sender, System.EventArgs e) {
			if(infoPathChanged){
				if(File.Exists(infoPathTextBox.Text)){
					cfg.Path=infoPath=infoPathTextBox.Text;
					//					SaveCfg();
					infoPathChanged=false;
					info.RestoreFrom(cfg.Path);
					try{
						ExampleLabel.Text=/*"Result:\n"+*/FormatData(infoFmt);
					}catch{
						ExampleLabel.Text="Format string not valid...";
					}
				}
				else
					MessageBox.Show(infoPathTextBox.Text,"File not exists");
			}
		}
		MediaInfo info=new MediaInfo();
		/// <summary>
		///   ,   -   .
		/// </summary>
		/// <returns></returns>
		string FormatData(string format){
			return string.Format(format,
				info.Name/*0*/,info.Album/*1*/,info.Artist/*2*/,info.Genre/*3*/,
				info.FileType/*4*/,info.Bitrate/*5*/,info.Duration/*6*/,
				info.PlayerVersion/*7*/);
		}

		bool infoFmtChanged=false;
		private void infoFmtTextBox_TextChanged(object sender, System.EventArgs e) {
			infoFmtChanged=true;
			try{
				string tmp=FormatData(infoFmtTextBox.Text);
				ExampleLabel.Text=/*"Result:\n"+*/tmp;
				infoFmt=infoFmtTextBox.Text;
				cfg.Format=new Regex("\r\n").Split(infoFmtTextBox.Text);//.Split(Environment.NewLine*/"\r\n".ToCharArray());
				infoFmtChanged=false;
			}catch{
				ExampleLabel.Text="";
			}
		}

		private void infoFmtTextBox_Leave(object sender, System.EventArgs e) {}

		private void SaveButton_Click(object sender, System.EventArgs e) {
			if(!infoFmtChanged)
				SaveCfg();
			else
				MessageBox.Show(infoFmtTextBox.Text,"Format String not valid");
		}

		private void CancelButton_Click(object sender, System.EventArgs e) {
			this.Close();
		}

		private void OkButton_Click(object sender, System.EventArgs e) {
			string infostr=FormatData(Join(cfg.Format,Environment.NewLine));
			if(infostr!=""){
				//Clipboard.SetDataObject(null,true);
				Clipboard.SetDataObject(infostr,true);
//				MessageBox.Show(infostr);
			}
			else{
				Clipboard.SetDataObject("<< WMP has a rest >>");
				//MessageBox.Show("???");
			}

			this.Close();
		}
	}

	public class NowPlayingPluginConfig : Config{
		string[] infoFmt=new string[]{"[WMP {7}]: {0} [by {2}]"};
		[XmlElement("format")]
		public string[] Format{
			get{return infoFmt;} set{infoFmt=value;}
		}
		string infoPath=@"C:\Program Files\DkmS\Wmp Now\Msg\audio.wmpnow";
		[XmlElement("path")]
		public string Path{get{return infoPath;} set{infoPath=value;}}
	}

}
